---
title: catch
type: processor
status: stable
categories: ["Composition"]
---

<!--
     THIS FILE IS AUTOGENERATED!

     To make changes please edit the contents of:
     lib/processor/catch.go
-->

import Tabs from '@theme/Tabs';
import TabItem from '@theme/TabItem';


Applies a list of child processors _only_ when a previous processing step has
failed.

```yaml
# Config fields, showing default values
label: ""
catch: []
```

Behaves similarly to the [`for_each`](/docs/components/processors/for_each) processor, where a
list of child processors are applied to individual messages of a batch. However,
processors are only applied to messages that failed a processing step prior to
the catch.

For example, with the following config:

```yaml
- foo:
    foofield1: meow
- catch:
  - bar:
      barfield1: woof
  - baz: {}
```

If the processor `foo` fails for a particular message, that message
will be fed into the processors `bar` and `baz`. Messages that do not
fail for the processor `foo` will skip these processors.

When messages leave the catch block their fail flags are cleared. This processor
is useful for when it's possible to recover failed messages, or when special
actions (such as logging/metrics) are required before dropping them.

More information about error handing can be found [here](/docs/configuration/error_handling).


